# Copyright (c) 2017, Peter Frank Perroni (pfperroni@gmail.com)
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# Additionally, if used for any scientific purpose, the following reference
# must be cited:
# 
# Peter Frank Perroni, Daniel Weingaertner, and Myriam Regattieri Delgado.
# 2017. Estimating Stop Conditions of Swarm Based Stochastic Metaheuristic
# Algorithms. In Proceedings of GECCO '17, Berlin, Germany, July 15-19, 2017,
# pg 43-50. DOI: http://dx.doi.org/10.1145/3071178.3071326
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.

# fitnessFunction.cpp
#
# Created on: 02/Jul/2017
# Author: Peter Frank Perroni (pfperroni@gmail.com)
#
# This module defines the fitness function that will be called from CSMOn C++ API.

import math

# Fitness Function.
def f(x, n):
    # Put your fitness function here.
    PI = 3.141592653589793238462643383279
    s = 0
    for i in range(0, n):
        s += x[i]*x[i] - 10 * math.cos(2 * PI * x[i])
    return 10 * n + s
